// D import file generated from '/build/buildd/ldc-0.10.0/runtime/druntime/src/core/demangle.d'
module core.demangle;
debug (trace)
{
    import core.stdc.stdio : printf;
}
debug (info)
{
    import core.stdc.stdio : printf;
}
import core.stdc.stdio : snprintf;
import core.stdc.string : memmove;
import core.stdc.stdlib : strtold;
private struct Demangle
{
    enum AddType 
{
no,
yes,
}
    this(const(char)[] buf_, char[] dst_ = null)
{
this(buf_,AddType.yes,dst_);
}
    this(const(char)[] buf_, AddType addType_, char[] dst_ = null)
{
buf = buf_;
addType = addType_;
dst = dst_;
}
    enum size_t minBufSize = 4000;
    const(char)[] buf = null;
    char[] dst = null;
    size_t pos = 0;
    size_t len = 0;
    AddType addType = AddType.yes;
    static class ParseException : Exception
{
    this(string msg)
{
super(msg);
}
}

    static class OverflowException : Exception
{
    this(string msg)
{
super(msg);
}
}

    static void error(string msg = "Invalid symbol");

    static void overflow(string msg = "Buffer overflow");

    static bool isAlpha(char val)
{
return 'a' <= val && 'z' >= val || 'A' <= val && 'Z' >= val;
}

    static bool isDigit(char val)
{
return '0' <= val && '9' >= val;
}

    static bool isHexDigit(char val)
{
return '0' <= val && '9' >= val || 'a' <= val && 'f' >= val || 'A' <= val && 'F' >= val;
}

    static ubyte ascii2hex(char val)
{
if (val >= 'a' && val <= 'f')
return cast(ubyte)(val - 'a' + 10);
if (val >= 'A' && val <= 'F')
return cast(ubyte)(val - 'A' + 10);
if (val >= '0' && val <= '9')
return cast(ubyte)(val - '0');
error();
return 0;
}

    static bool contains(const(char)[] a, const(char)[] b)
{
return a.length && b.ptr >= a.ptr && b.ptr + b.length <= a.ptr + a.length;
}

    char[] shift(const(char)[] val);
    char[] append(const(char)[] val);
    char[] put(const(char)[] val)
{
if (val.length)
{
if (!contains(dst[0..len],val))
return append(val);
return shift(val);
}
return null;
}
    char[] putAsHex(size_t val, int width = 0);
    void pad(const(char)[] val)
{
if (val.length)
{
append(" ");
put(val);
}
}
    void silent(lazy void dg);
    char tok()
{
if (pos < buf.length)
return buf[pos];
return (char).init;
}
    void test(char val)
{
if (val != tok())
error();
}
    void next()
{
if (pos++ >= buf.length)
error();
}
    void match(char val)
{
test(val);
next();
}
    void match(const(char)[] val);
    void eat(char val)
{
if (val == tok())
next();
}
    const(char)[] sliceNumber();
    size_t decodeNumber();
    size_t decodeNumber(const(char)[] num);
    void parseReal();
    void parseLName();
    char[] parseType(char[] name = null);
    enum IsDelegate 
{
no,
yes,
}
    char[] parseTypeFunction(char[] name = null, IsDelegate isdg = IsDelegate.no);
    void parseValue(char[] name = null, char type = '\x00');
    void parseIntegerValue(char[] name = null, char type = '\x00');
    void parseTemplateArgs();
    void parseTemplateInstanceName();
    bool mayBeTemplateInstanceName();
    void parseSymbolName();
    char[] parseQualifiedName();
    void parseMangledName();
    char[] opCall();
}

char[] demangle(const(char)[] buf, char[] dst = null)
{
auto d = Demangle(buf,dst);
return d();
}
string decodeDmdString(const(char)[] ln, ref size_t p);
